--- /dev/null
+[submodule "nixops/secrets"]
+ path = nixops/secrets
+ url = gitolite@git.immae.eu:perso/Immae/Config/Nix/Nixops/Secrets
-subrecipes = setup nix-info
+subrecipes = setup nix-info edit_env
subrecipes += nixops ssh-eldiron ssh-backup-2 ssh-monitoring-1
subrecipes += info debug dry-run build upload deploy deploy-reboot reboot
subrecipes += list-generations delete-generations cleanup
-subrecipes += pull pull_environment pull_deployment deployment_is_set push push_deployment push_environment
+subrecipes += pull_deployment deployment_is_set push_deployment
${subrecipes}:
@$(MAKE) --no-print-directory -C nixops/ $@
.PHONY: ${subrecipes}
export
-ifndef NIXOPS_CONFIG_PASS_SUBTREE_PATH
- $(error Please set NIXOPS_CONFIG_PASS_SUBTREE_PATH to the password-store subtree path)
-endif
-
+PASSWORD_STORE_DIR = $(shell pwd)/secrets
NIXOPS_STATE ?= ./state/eldiron.nixops
NIXOPS_DEPLOYMENT = cef694f3-081d-11e9-b31f-0242ec186adf
nixpkgs ?= $(shell cat ../nix/sources.json | jq -r '."nixpkgs-nixops".url')
endif
SSH_ARGS ?=
+edit_env:
+ pass edit Nixops/files/environment.nix || true
+
nixops:
$(NIXOPS_PRIV) $(NIXOPS_ARGS)
.PHONY: cleanup
###### Pull environment and deployment from remote
-# Don't include pull_deployment by default as this should happen only rarely
-pull: pull_environment;
-.PHONY: pull
-
-pull_environment:
-ifndef NIXOPS_CONFIG_PASS_SUBTREE_REMOTE
- $(error "Please set NIXOPS_CONFIG_PASS_SUBTREE_REMOTE to the password-store subtree remote name")
-endif
- pass git subtree pull --prefix=$(NIXOPS_CONFIG_PASS_SUBTREE_PATH) $(NIXOPS_CONFIG_PASS_SUBTREE_REMOTE) master
-.PHONY: pull_environment
-
pull_deployment:
@if $(NIXOPS) info -d $(NIXOPS_DEPLOYMENT) 2>/dev/null >/dev/null ; then \
echo "This will remove your current deployment file and recreate it!. Continue? [y/N]" && \
[ "$$y" = "y" -o "$$y" = "Y" ] && \
$(NIXOPS) delete --force -d $(NIXOPS_DEPLOYMENT); \
fi
- pass show $(NIXOPS_CONFIG_PASS_SUBTREE_PATH)/Nixops/Deployment | $(NIXOPS) import
+ pass show Nixops/Deployment | $(NIXOPS) import
$(NIXOPS) modify -d $(NIXOPS_DEPLOYMENT) "$$(pwd)/default.nix"
.PHONY: pull_deployment
$(NIXOPS) info -d $(NIXOPS_DEPLOYMENT) 2>/dev/null >/dev/null
.PHONY: deployment_is_set
-###### Push environment and deployment information to password store
-push: push_deployment push_environment;
-.PHONY: push
-
+###### Push deployment information to password store
push_deployment:
- $(NIXOPS) export | pass insert -m $(NIXOPS_CONFIG_PASS_SUBTREE_PATH)/Nixops/Deployment
-.PHONY: push_deployment
-
-push_environment:
-ifndef NIXOPS_CONFIG_PASS_SUBTREE_REMOTE
- $(error "Please set NIXOPS_CONFIG_PASS_SUBTREE_REMOTE to the password-store subtree remote name")
-endif
- pass git subtree push --prefix=$(NIXOPS_CONFIG_PASS_SUBTREE_PATH) $(NIXOPS_CONFIG_PASS_SUBTREE_REMOTE) master
-.PHONY: push_environment
+ $(NIXOPS) export | pass insert -m Nixops/Deployment
+.PHONY: push
set -euo pipefail
-RemoteRepo="gitolite@git.immae.eu:perso/Immae/Prive/Password_store/Sites"
MAKEFILE_DIR="$( cd "$( dirname $( dirname "${BASH_SOURCE[0]}" ))" >/dev/null 2>&1 && pwd )"
if ! which nix 2>/dev/null >/dev/null; then
exit 1
fi
-if [ -z "$NIXOPS_CONFIG_PASS_SUBTREE_REMOTE" \
- -o -z "$NIXOPS_CONFIG_PASS_SUBTREE_PATH" ]; then
- cat <<-EOF
- Two environment variables are needed to setup the password store:
- NIXOPS_CONFIG_PASS_SUBTREE_PATH : path where the subtree will be imported
- NIXOPS_CONFIG_PASS_SUBTREE_REMOTE : remote name to give to the repository
- EOF
- exit 1
-fi
-
-if ! pass $NIXOPS_CONFIG_PASS_SUBTREE_PATH > /dev/null 2>/dev/null; then
- cat <<-EOF
- /!\ This will modify your password store to add and import a subtree
- with the specific passwords files. Choose a path that doesn’t exist
- yet in your password store.
- > pass git remote add $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE $RemoteRepo
- > pass git subtree add --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
- Later, you can use pull_environment and push_environment scripts to
- update the passwords when needed
- Continue? [y/N]
- EOF
- read y
- if [ "$y" = "y" -o "$y" = "Y" ]; then
- pass git remote add $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE $RemoteRepo
- pass git subtree add --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
- else
- echo "Aborting"
- exit 1
- fi
-fi
-
-# Repull it before adding keys, just in case
-make -C $MAKEFILE_DIR pull_environment
-
-gpg_keys=$(pass ls $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/GPGKeys | sed -e "1d" | cut -d" " -f2)
+gpg_keys=$(pass ls Nixops/GPGKeys | sed -e "1d" | cut -d" " -f2)
for key in $gpg_keys; do
- content=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/GPGKeys/$key)
+ content=$(pass show Nixops/GPGKeys/$key)
fpr=$(echo "$content" | gpg --import-options show-only --import --with-colons | grep -e "^pub" | cut -d':' -f5)
gpg --list-key "$fpr" >/dev/null 2>/dev/null && imported=yes || imported=no
# /usr/share/doc/gnupg/DETAILS field 2
exit 1;
fi
-if [ -z "$NIXOPS_CONFIG_PASS_SUBTREE_PATH" ]; then
- echo "Please set NIXOPS_CONFIG_PASS_SUBTREE_PATH to the password-store subtree path"
- exit 1;
-fi
-
TEMP=$(mktemp -d /tmp/XXXXXX-nixops-files)
chmod go-rwx $TEMP
trap finish EXIT
# pass cannot "just" list files in a directory without showing a tree :(
-files=$(pass ls $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/files | sed -e '1d' -e 's/^.* //')
+files=$(pass ls Nixops/files | sed -e '1d' -e 's/^.* //')
for file in $files; do
- pass show "$NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/files/$file" > $TEMP/$file
+ pass show "Nixops/files/$file" > $TEMP/$file
done
$NIXOPS set-args --argstr privateFiles "$TEMP"
--- /dev/null
+Subproject commit d34d5490226809ff9863ce4e66bd59a68ead861c